package com.rootsoft.audiorecorder;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.rootsoft.audiorecorder", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "com.rootsoft.audiorecorder", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public com.rootsoft.audiorecorder.AudioRecorder _ar = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 17;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 18;BA.debugLine="AR.Initialize()";
mostCurrent._ar.Initialize(processBA);
 };
 //BA.debugLineNum = 20;BA.debugLine="Activity.AddMenuItem(\"Prepare\",\"mnuPrepare\")";
mostCurrent._activity.AddMenuItem("Prepare","mnuPrepare");
 //BA.debugLineNum = 21;BA.debugLine="Activity.AddMenuItem(\"Start\",\"mnuStart\")";
mostCurrent._activity.AddMenuItem("Start","mnuStart");
 //BA.debugLineNum = 22;BA.debugLine="Activity.AddMenuItem(\"Stop\",\"mnuStop\")";
mostCurrent._activity.AddMenuItem("Stop","mnuStop");
 //BA.debugLineNum = 23;BA.debugLine="Activity.AddMenuItem(\"isRecording\",\"mnuisRecording\")";
mostCurrent._activity.AddMenuItem("isRecording","mnuisRecording");
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 31;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 11;BA.debugLine="Dim AR As AudioRecorder";
mostCurrent._ar = new com.rootsoft.audiorecorder.AudioRecorder();
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static String  _mnuisrecording_click() throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub mnuisRecording_Click";
 //BA.debugLineNum = 58;BA.debugLine="Toastmessageshow(AR.isRecording,false)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(String.valueOf(mostCurrent._ar.isRecording()),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return "";
}
public static String  _mnuprepare_click() throws Exception{
 //BA.debugLineNum = 44;BA.debugLine="Sub mnuPrepare_Click";
 //BA.debugLineNum = 46;BA.debugLine="ToastMessageShow(\"Preparing the AudioRecorder.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Preparing the AudioRecorder.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 47;BA.debugLine="AR.AudioSource = AR.AS_MIC";
mostCurrent._ar.setAudioSource(mostCurrent._ar.AS_MIC);
 //BA.debugLineNum = 48;BA.debugLine="AR.OutputFormat = AR.OF_THREE_GPP";
mostCurrent._ar.setOutputFormat(mostCurrent._ar.OF_THREE_GPP);
 //BA.debugLineNum = 49;BA.debugLine="AR.AudioEncoder = AR.AE_AMR_NB";
mostCurrent._ar.setAudioEncoder(mostCurrent._ar.AE_AMR_NB);
 //BA.debugLineNum = 50;BA.debugLine="AR.setOutputFile(File.DirDefaultExternal,\"myRecording.wav\")";
mostCurrent._ar.setOutputFile(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"myRecording.wav");
 //BA.debugLineNum = 51;BA.debugLine="AR.prepare()";
mostCurrent._ar.prepare();
 //BA.debugLineNum = 53;BA.debugLine="ToastMessageShow(\"AudioRecorder is ready to record.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("AudioRecorder is ready to record.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _mnustart_click() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub mnuStart_Click";
 //BA.debugLineNum = 36;BA.debugLine="ToastMessageShow(\"Recording started.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Recording started.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 37;BA.debugLine="Ar.Start";
mostCurrent._ar.start();
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _mnustop_click() throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub mnuStop_Click";
 //BA.debugLineNum = 41;BA.debugLine="ToastMessageShow(\"Recording stopped.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Recording stopped.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 42;BA.debugLine="Ar.Stop";
mostCurrent._ar.stop();
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
}
